#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform float GameTime;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec2 texCoord1;
in vec4 normal;

out vec4 fragColor;

#define SPEED 4

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    vec4 color2 = color;
    float anim = GameTime * 300;
    if (color.a < 0.1) discard;
    const float epsilon = 0.01;
    if (!(abs(color.a * 255. - 128) < epsilon || abs(color.a * 255. - 178) < epsilon || abs(color.a * 255. - 77) < epsilon || abs(color.a * 255. - 254) < epsilon)) color *= vertexColor * ColorModulator;
    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
    if (abs(color.a * 255 - 253) < epsilon){
        float theta = (sin(sin(anim)*14)*cos(sin(anim)*cos(anim))*sin(anim*20))*0.5+1.2;
        float theta2 = (sin(sin(anim*SPEED)*14)*cos(sin(anim*SPEED)*cos(anim*SPEED))*sin(anim*SPEED*20))*0.1;
        color = mix(color, color2, clamp(theta+theta2, 0, 1));
        fragColor = color;
    }
}
